Index: inc/core/class.dc.auth.php
===================================================================
--- inc/core/class.dc.auth.php	(revision 852)
+++ inc/core/class.dc.auth.php	(revision 527)
@@ -75,5 +75,8 @@
 			'publish' => __('publish entries and comments'),
 			'delete' => __('delete entries and comments'),
-			'contentadmin' => __('manage all entries and comments')
+			'contentadmin' => __('manage all entries and comments'),
+			'categories' => __('manage categories'),
+			'media' => __('manage their own media items'),
+			'media_admin' => __('manage all media items')
 		);
 	}
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 877)
+++ inc/core/class.dc.blog.php	(revision 836)
@@ -55,4 +55,7 @@
 	
 	private $post_status = array();
+	private $comment_status = array();
+	
+	private $categories;
 	
 	/** @var boolean Disallow entries password protection */
@@ -92,5 +95,10 @@
 			$this->post_status['0'] = __('unpublished');
 			$this->post_status['1'] = __('published');
-						
+			
+			$this->comment_status['-2'] = __('junk');
+			$this->comment_status['-1'] = __('pending');
+			$this->comment_status['0'] = __('unpublished');
+			$this->comment_status['1'] = __('published');
+			
 			# --BEHAVIOR-- coreBlogConstruct
 			$this->core->callBehavior('coreBlogConstruct',$this);
@@ -137,4 +145,13 @@
 	}
 	
+	/**
+	Returns an array of available comment status codes and names.
+	
+	@return	<b>array</b> Simple array with codes in keys and names in value
+	*/
+	public function getAllCommentStatus()
+	{
+		return $this->comment_status;
+	}
 	
 	/**
@@ -167,4 +184,451 @@
 		$this->core->callBehavior('coreBlogAfterTriggerBlog',$cur);
 	}
+	
+	/**
+	Updates comment and trackback counters in post table. Should be called
+	every time a comment or trackback is added, removed or changed its status.
+	
+	@param	id		<b>integer</b>		Comment ID
+	@param	del		<b>boolean</b>		If comment is delete, set this to true
+	*/
+	public function triggerComment($id,$del=false)
+	{
+		$id = (integer) $id;
+		
+		$strReq = 'SELECT post_id, comment_trackback '.
+				'FROM '.$this->prefix.'comment '.
+				'WHERE comment_id = '.$id.' ';
+		
+		$rs = $this->con->select($strReq);
+		
+		$post_id = $rs->post_id;
+		$tb = (boolean) $rs->comment_trackback;
+		
+		$strReq = 'SELECT COUNT(post_id) '.
+				'FROM '.$this->prefix.'comment '.
+				'WHERE post_id = '.(integer) $post_id.' '.
+				'AND comment_trackback = '.(integer) $tb.' '.
+				'AND comment_status = 1 ';
+		
+		if ($del) {
+			$strReq .= 'AND comment_id <> '.$id.' ';
+		}
+		
+		$rs = $this->con->select($strReq);
+		
+		$cur = $this->con->openCursor($this->prefix.'post');
+		
+		if ($rs->isEmpty()) {
+			return;
+		}
+		
+		if ($tb) {
+			$cur->nb_trackback = (integer) $rs->f(0);
+		} else {
+			$cur->nb_comment = (integer) $rs->f(0);
+		}
+		
+		$cur->update('WHERE post_id = '.(integer) $post_id);
+	}
+	//@}
+	
+	/// @name Categories management methods
+	//@{
+	public function categories()
+	{
+		if (!($this->categories instanceof dcCategories)) {
+			$this->categories = new dcCategories($this->core);
+		}
+		
+		return $this->categories;
+	}
+	
+	/**
+	Retrieves categories. <var>$params</var> is an associative array which can
+	take the following parameters:
+	
+	- post_type: Get only entries with given type (default "post")
+	- cat_url: filter on cat_url field
+	- cat_id: filter on cat_id field
+	- start: start with a given category
+	- level: categories level to retrieve
+	
+	@param	params	<b>array</b>		Parameters
+	@return	<b>record</b>
+	*/
+	public function getCategories($params=array())
+	{
+		$c_params = array();
+		if (isset($params['post_type'])) {
+			$c_params['post_type'] = $params['post_type'];
+			unset($params['post_type']);
+		}
+		$counter = $this->getCategoriesCounter($c_params);
+		
+		$without_empty = $this->core->auth->userID() == false; # For public display
+		
+		$start = isset($params['start']) ? (integer) $params['start'] : 0;
+		$l = isset($params['level']) ? (integer) $params['level'] : 0;
+		
+		$rs = $this->categories()->getChildren($start,null,'desc');
+		
+		# Get each categories total posts count
+		$data = array();
+		$stack = array();
+		$level = 0;
+		$cols = $rs->columns();
+		while ($rs->fetch())
+		{
+			$nb_post = isset($counter[$rs->cat_id]) ? (integer) $counter[$rs->cat_id] : 0;
+			
+			if ($rs->level > $level) {
+				$nb_total = $nb_post;
+				$stack[$rs->level] = (integer) $nb_post;
+			} elseif ($rs->level == $level) {
+				$nb_total = $nb_post;
+				$stack[$rs->level] += $nb_post;
+			} else {
+				$nb_total = $stack[$rs->level+1] + $nb_post;
+				if (isset($stack[$rs->level])) {
+					$stack[$rs->level] += $nb_total;
+				} else {
+					$stack[$rs->level] = $nb_total;
+				}
+				unset($stack[$rs->level+1]);
+			}
+			
+			if ($nb_total == 0 && $without_empty) {
+				continue;
+			}
+			
+			$level = $rs->level;
+			
+			$t = array();
+			foreach ($cols as $c) {
+				$t[$c] = $rs->f($c);
+			}
+			$t['nb_post'] = $nb_post;
+			$t['nb_total'] = $nb_total;
+			
+			if ($l == 0 || ($l > 0 && $l == $rs->level)) {
+				array_unshift($data,$t);
+			}
+		}
+		
+		# We need to apply filter after counting
+		if (isset($params['cat_id']) && $params['cat_id'] !== '')
+		{
+			$found = false;
+			foreach ($data as $v) {
+				if ($v['cat_id'] == $params['cat_id']) {
+					$found = true;
+					$data = array($v);
+					break;
+				}
+			}
+			if (!$found) {
+				$data = array();
+			}
+		}
+		
+		if (isset($params['cat_url']) && ($params['cat_url'] !== '') 
+			&& !isset($params['cat_id']))
+		{
+			$found = false;
+			foreach ($data as $v) {
+				if ($v['cat_url'] == $params['cat_url']) {
+					$found = true;
+					$data = array($v);
+					break;
+				}
+			}
+			if (!$found) {
+				$data = array();
+			}
+		}
+		
+		return staticRecord::newFromArray($data);
+	}
+	
+	/**
+	Retrieves a category by its ID.
+	
+	@param	id		<b>integer</b>		Category ID
+	@return	<b>record</b>
+	*/
+	public function getCategory($id)
+	{
+		return $this->getCategories(array('cat_id' => $id));
+	}
+	
+	/**
+	Retrieves parents of a given category.
+	
+	@param	id		<b>integer</b>		Category ID
+	@return	<b>record</b>
+	*/
+	public function getCategoryParents($id)
+	{
+		return $this->categories()->getParents($id);
+	}
+	
+	/**
+	Retrieves first parent of a given category.
+	
+	@param	id		<b>integer</b>		Category ID
+	@return	<b>record</b>
+	*/
+	public function getCategoryParent($id)
+	{
+		return $this->categories()->getParent($id);
+	}
+	
+	/**
+	Retrieves all category's first children
+	
+	@param	id		<b>integer</b>		Category ID
+	@return	<b>record</b>
+	*/
+	public function getCategoryFirstChildren($id)
+	{
+		return $this->getCategories(array('start' => $id,'level' => $id == 0 ? 1 : 2));
+	}
+	
+	private function getCategoriesCounter($params=array())
+	{
+		$strReq =
+		'SELECT  C.cat_id, COUNT(P.post_id) AS nb_post '.
+		'FROM '.$this->prefix.'category AS C '.
+		'JOIN '.$this->prefix."post P ON (C.cat_id = P.cat_id AND P.blog_id = '".$this->con->escape($this->id)."' ) ".
+		"WHERE C.blog_id = '".$this->con->escape($this->id)."' ";
+		
+		if (!$this->core->auth->userID()) {
+			$strReq .= 'AND P.post_status = 1 ';
+		}
+		
+		if (!empty($params['post_type'])) {
+			$strReq .= 'AND P.post_type '.$this->con->in($params['post_type']);
+		}
+		
+		$strReq .= 'GROUP BY C.cat_id ';
+		
+		$rs = $this->con->select($strReq);
+		$counters = array();
+		while ($rs->fetch()) {
+			$counters[$rs->cat_id] = $rs->nb_post;
+		}
+		
+		return $counters;
+	}
+	
+	/**
+	Creates a new category. Takes a cursor as input and returns the new category
+	ID.
+	
+	@param	cur		<b>cursor</b>		Category cursor
+	@return	<b>integer</b>		New category ID
+	*/
+	public function addCategory($cur,$parent=0)
+	{
+		if (!$this->core->auth->check('categories',$this->id)) {
+			throw new Exception(__('You are not allowed to add categories'));
+		}
+		
+		$url = array();
+		if ($parent != 0)
+		{
+			$rs = $this->getCategory($parent);
+			if ($rs->isEmpty()) {
+				$url = array();
+			} else {
+				$url[] = $rs->cat_url;
+			}
+		}
+		
+		if ($cur->cat_url == '') {
+			$url[] = text::tidyURL($cur->cat_title,false);
+		} else {
+			$url[] = $cur->cat_url;
+		}
+		
+		$cur->cat_url = implode('/',$url);
+		
+		$this->getCategoryCursor($cur);
+		$cur->blog_id = (string) $this->id;
+		
+		# --BEHAVIOR-- coreBeforeCategoryCreate
+		$this->core->callBehavior('coreBeforeCategoryCreate',$this,$cur);
+		
+		$this->categories()->addNode($cur,$parent);
+		
+		# --BEHAVIOR-- coreAfterCategoryCreate
+		$this->core->callBehavior('coreAfterCategoryCreate',$this,$cur);
+		$this->triggerBlog();
+		
+		return $cur->cat_id;
+	}
+	
+	/**
+	Updates an existing category.
+	
+	@param	id		<b>integer</b>		Category ID
+	@param	cur		<b>cursor</b>		Category cursor
+	*/
+	public function updCategory($id,$cur)
+	{
+		if (!$this->core->auth->check('categories',$this->id)) {
+			throw new Exception(__('You are not allowed to update categories'));
+		}
+		
+		if ($cur->cat_url == '')
+		{
+			$url = array();
+			$rs = $this->categories()->getParents($id);
+			while ($rs->fetch()) {
+				if ($rs->index() == $rs->count()-1) {
+					$url[] = $rs->cat_url;
+				}
+			}
+			
+			
+			$url[] = text::tidyURL($cur->cat_title,false);
+			$cur->cat_url = implode('/',$url);
+		}
+		
+		$this->getCategoryCursor($cur,$id);
+		
+		# --BEHAVIOR-- coreBeforeCategoryUpdate
+		$this->core->callBehavior('coreBeforeCategoryUpdate',$this,$cur);
+		
+		$cur->update(
+		'WHERE cat_id = '.(integer) $id.' '.
+		"AND blog_id = '".$this->con->escape($this->id)."' ");
+		
+		# --BEHAVIOR-- coreAfterCategoryUpdate
+		$this->core->callBehavior('coreAfterCategoryUpdate',$this,$cur);
+		
+		$this->triggerBlog();
+	}
+	
+	/**
+	DEPRECATED METHOD. Use dcBlog::setCategoryParent and dcBlog::moveCategory
+	instead.
+	
+	@param	id		<b>integer</b>		Category ID
+	@param	order	<b>integer</b>		Category position
+	*/
+	public function updCategoryOrder($id,$order)
+	{
+		return;
+	}
+	
+	/**
+	Set a category parent
+	
+	@param	id		<b>integer</b>		Category ID
+	@param	parent	<b>integer</b>		Parent Category ID
+	*/
+	public function setCategoryParent($id,$parent)
+	{
+		$this->categories()->setNodeParent($id,$parent);
+		$this->triggerBlog();
+	}
+	
+	/**
+	Set category position
+	
+	@param	id		<b>integer</b>		Category ID
+	@param	sibling	<b>integer</b>		Sibling Category ID
+	@param	move		<b>integer</b>		Order (before|after)
+	*/
+	public function setCategoryPosition($id,$sibling,$move)
+	{
+		$this->categories()->setNodePosition($id,$sibling,$move);
+		$this->triggerBlog();
+	}
+	
+	/**
+	Deletes a category.
+	
+	@param	id		<b>integer</b>		Category ID
+	*/
+	public function delCategory($id)
+	{
+		if (!$this->core->auth->check('categories',$this->id)) {
+			throw new Exception(__('You are not allowed to delete categories'));
+		}
+		
+		$strReq = 'SELECT COUNT(post_id) AS nb_post '.
+				'FROM '.$this->prefix.'post '.
+				'WHERE cat_id = '.(integer) $id.' '.
+				"AND blog_id = '".$this->con->escape($this->id)."' ";
+		
+		$rs = $this->con->select($strReq);
+		
+		if ($rs->nb_post > 0) {
+			throw new Exception(__('This category is not empty.'));
+		}
+		
+		$this->categories()->deleteNode($id,true);
+		$this->triggerBlog();
+	}
+	
+	/**
+	Reset categories order and relocate them to first level
+	*/
+	public function resetCategoriesOrder()
+	{
+		if (!$this->core->auth->check('categories',$this->id)) {
+			throw new Exception(__('You are not allowed to reset categories order'));
+		}
+		
+		$this->categories()->resetOrder();
+		$this->triggerBlog();
+	}
+	
+	private function checkCategory($title,$url,$id=null)
+	{
+		$strReq = 'SELECT cat_id '.
+				'FROM '.$this->prefix.'category '.
+				"WHERE cat_url = '".$this->con->escape($url)."' ".
+				"AND blog_id = '".$this->con->escape($this->id)."' ";
+		
+		if ($id !== null) {
+			$strReq .= 'AND cat_id <> '.(integer) $id.' ';
+		}
+		
+		$rs = $this->con->select($strReq);
+		
+		if (!$rs->isEmpty()) {
+			throw new Exception(__('Category URL must be unique.'));
+		}
+	}
+	
+	private function getCategoryCursor($cur,$id=null)
+	{
+		if ($cur->cat_title == '') {
+			throw new Exception(__('You must provide a category title'));
+		}
+		
+		# If we don't have any cat_url, let's do one
+		if ($cur->cat_url == '') {
+			$cur->cat_url = text::tidyURL($cur->cat_title,false);
+		}
+		
+		# Still empty ?
+		if ($cur->cat_url == '') {
+			throw new Exception(__('You must provide a category URL'));
+		} else {
+			$cur->cat_url = text::tidyURL($cur->cat_url,true);
+		}
+		
+		# Check if title or url are unique
+		$this->checkCategory($cur->cat_title,$cur->cat_url,$id);
+		
+		if ($cur->cat_desc !== null) {
+			$cur->cat_desc = $this->core->HTMLfilter($cur->cat_desc);
+		}
+	}
+	//@}
 	
 	/// @name Entries management methods
@@ -179,4 +643,8 @@
 	- post_url: Get entry with given post_url field
 	- user_id: (integer) Get entries belonging to given user ID
+	- cat_id: (string or array) Get entries belonging to given category ID
+	- cat_id_not: deprecated (use cat_id with "id ?not" instead)
+	- cat_url: (string or array) Get entries belonging to given category URL
+	- cat_url_not: deprecated (use cat_url with "url ?not" instead)
 	- post_status: (integer) Get entries with given post_status
 	- post_selected: (boolean) Get select flaged entries
@@ -193,4 +661,7 @@
 	- sql_only : return the sql request instead of results. Only ids are selected
 	
+	Please note that on every cat_id or cat_url, you can add ?not to exclude
+	the category and ?sub to get subcategories.
+	
 	@param	params		<b>array</b>		Parameters
 	@param	count_only	<b>boolean</b>		Only counts results
@@ -226,15 +697,18 @@
 			
 			$strReq =
-			'SELECT P.post_id, P.blog_id, P.user_id, post_dt, '.
-			'post_tz, post_creadt, post_upddt, post_format, '.
+			'SELECT P.post_id, P.blog_id, P.user_id, P.cat_id, post_dt, '.
+			'post_tz, post_creadt, post_upddt, post_format, post_password, '.
 			'post_url, post_lang, post_title, '.$content_req.
 			'post_type, post_meta, post_status, post_selected, post_position, '.
+			'post_open_comment, post_open_tb, nb_comment, nb_trackback, '.
 			'U.user_name, U.user_firstname, U.user_displayname, U.user_email, '.
-			'U.user_url ';
+			'U.user_url, '.
+			'C.cat_title, C.cat_url, C.cat_desc ';
 		}
 		
 		$strReq .=
 		'FROM '.$this->prefix.'post P '.
-		'INNER JOIN '.$this->prefix.'user U ON U.user_id = P.user_id ';
+		'INNER JOIN '.$this->prefix.'user U ON U.user_id = P.user_id '.
+		'LEFT OUTER JOIN '.$this->prefix.'category C ON P.cat_id = C.cat_id ';
 		
 		if (!empty($params['from'])) {
@@ -246,5 +720,10 @@
 		
 		if (!$this->core->auth->check('contentadmin',$this->id)) {
-			$strReq .= 'AND ((post_status = 1) ';
+			$strReq .= 'AND ((post_status = 1 ';
+			
+			if ($this->without_password) {
+				$strReq .= 'AND post_password IS NULL ';
+			}
+			$strReq .= ') ';
 			
 			if ($this->core->auth->userID()) {
@@ -282,4 +761,25 @@
 		if (!empty($params['user_id'])) {
 			$strReq .= "AND U.user_id = '".$this->con->escape($params['user_id'])."' ";
+		}
+		
+		if (isset($params['cat_id']) && $params['cat_id'] !== '')
+		{
+			if (!is_array($params['cat_id'])) {
+				$params['cat_id'] = array($params['cat_id']);
+			}
+			if (!empty($params['cat_id_not'])) {
+				array_walk($params['cat_id'],create_function('&$v,$k','$v=$v." ?not";'));
+			}
+			$strReq .= 'AND '.$this->getPostsCategoryFilter($params['cat_id'],'cat_id').' ';
+		}
+		elseif (isset($params['cat_url']) && $params['cat_url'] !== '')
+		{
+			if (!is_array($params['cat_url'])) {
+				$params['cat_url'] = array($params['cat_url']);
+			}
+			if (!empty($params['cat_url_not'])) {
+				array_walk($params['cat_url'],create_function('&$v,$k','$v=$v." ?not";'));
+			}
+			$strReq .= 'AND '.$this->getPostsCategoryFilter($params['cat_url'],'cat_url').' ';
 		}
 		
@@ -354,12 +854,13 @@
 		}
 		
-		$posts = $this->con->select($strReq);
-		$posts->core = $this->core;
-		$posts->extend('rsExtPost');
+		$rs = $this->con->select($strReq);
+		$rs->core = $this->core;
+		$rs->_nb_media = array();
+		$rs->extend('rsExtPost');
 		
 		# --BEHAVIOR-- coreBlogGetPosts
-		$this->core->callBehavior('coreBlogGetPosts',$posts);
-		
-		return $posts;
+		$this->core->callBehavior('coreBlogGetPosts',$rs);
+		
+		return $rs;
 	}
 	
@@ -371,8 +872,9 @@
 	@param	post_id				<b>integer</b>		Post ID
 	@param	dir					<b>integer</b>		Search direction
+	@param	restrict_to_category	<b>boolean</b>		Restrict to post with same category
 	@param	restrict_to_lang		<b>boolean</b>		Restrict to post with same lang
 	@return	record
 	*/
-	public function getNextPost($post, $dir, $restrict_to_lang=false)
+	public function getNextPost($post,$dir,$restrict_to_category=false, $restrict_to_lang=false)
 	{
 		$dt = $post->post_dt;
@@ -397,15 +899,19 @@
 		') ';
 		
+		if ($restrict_to_category) {
+			$params['sql'] .= $post->cat_id ? 'AND P.cat_id = '.(integer) $post->cat_id.' ' : 'AND P.cat_id IS NULL ';
+		}
+		
 		if ($restrict_to_lang) {
 			$params['sql'] .= $post->post_lang ? 'AND P.post_lang = \''. $this->con->escape($post->post_lang) .'\' ': 'AND P.post_lang IS NULL ';
 		}
 		
-		$posts = $this->getPosts($params);
-		
-		if (count($posts) == 0) {
+		$rs = $this->getPosts($params);
+		
+		if ($rs->isEmpty()) {
 			return null;
 		}
 		
-		return $posts;
+		return $rs;
 	}
 	
@@ -431,5 +937,10 @@
 		
 		if (!$this->core->auth->check('contentadmin',$this->id)) {
-			$strReq .= 'AND ((post_status = 1) ';
+			$strReq .= 'AND ((post_status = 1 ';
+			
+			if ($this->without_password) {
+				$strReq .= 'AND post_password IS NULL ';
+			}
+			$strReq .= ') ';
 			
 			if ($this->core->auth->userID()) {
@@ -471,4 +982,6 @@
 	- month: (integer) Get dates for given month
 	- day: (integer) Get dates for given day
+	- cat_id: (integer) Category ID filter
+	- cat_url: Category URL filter
 	- post_lang: lang of the posts
 	- next: Get date following match
@@ -497,4 +1010,11 @@
 		$cat_field = $catReq = $limit = '';
 		
+		if (isset($params['cat_id']) && $params['cat_id'] !== '') {
+			$catReq = 'AND P.cat_id = '.(integer) $params['cat_id'].' ';
+			$cat_field = ', C.cat_url ';
+		} elseif (isset($params['cat_url']) && $params['cat_url'] !== '') {
+			$catReq = "AND C.cat_url = '".$this->con->escape($params['cat_url'])."' ";
+			$cat_field = ', C.cat_url ';
+		}
 		if (!empty($params['post_lang'])) {
 			$catReq = 'AND P.post_lang = \''. $params['post_lang'].'\' ';
@@ -502,11 +1022,18 @@
 		
 		$strReq = 'SELECT DISTINCT('.$this->con->dateFormat('post_dt',$dt_f).') AS dt '.
+				$cat_field.
 				',COUNT(P.post_id) AS nb_post '.
-				'FROM '.$this->prefix.'post P '.
+				'FROM '.$this->prefix.'post P LEFT JOIN '.$this->prefix.'category C '.
+				'ON P.cat_id = C.cat_id '.
 				"WHERE P.blog_id = '".$this->con->escape($this->id)."' ".
 				$catReq;
 		
 		if (!$this->core->auth->check('contentadmin',$this->id)) {
-			$strReq .= 'AND ((post_status = 1) ';
+			$strReq .= 'AND ((post_status = 1 ';
+			
+			if ($this->without_password) {
+				$strReq .= 'AND post_password IS NULL ';
+			}
+			$strReq .= ') ';
 			
 			if ($this->core->auth->userID()) {
@@ -554,4 +1081,6 @@
 		}
 		
+		$strReq .= 'GROUP BY dt '.$cat_field;
+		
 		$order = 'desc';
 		if (!empty($params['order']) && preg_match('/^(desc|asc)$/i',$params['order'])) {
@@ -563,7 +1092,7 @@
 		$limit;
 		
-		$dates = $this->con->select($strReq);
-		$dates->extend('rsExtDates');
-		return $dates;
+		$rs = $this->con->select($strReq);
+		$rs->extend('rsExtDates');
+		return $rs;
 	}
 	
@@ -585,12 +1114,10 @@
 		{
 			# Get ID
-			$max = $this->con->select(
+			$rs = $this->con->select(
 				'SELECT MAX(post_id) '.
 				'FROM '.$this->prefix.'post ' 
 				);
 			
-			$max = $max->current();
-			
-			$cur->post_id = (integer) $max->f(0) + 1;
+			$cur->post_id = (integer) $rs->f(0) + 1;
 			$cur->blog_id = (string) $this->id;
 			$cur->post_creadt = date('Y-m-d H:i:s');
@@ -670,7 +1197,7 @@
 					"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 			
-			$posts = $this->con->select($strReq);
-			
-			if (count($posts) == 0) {
+			$rs = $this->con->select($strReq);
+			
+			if ($rs->isEmpty()) {
 				throw new Exception(__('You are not allowed to edit this entry'));
 			}
@@ -712,7 +1239,7 @@
 					"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 			
-			$posts = $this->con->select($strReq);
-			
-			if (count($posts) == 0) {
+			$rs = $this->con->select($strReq);
+			
+			if ($rs->isEmpty()) {
 				throw new Exception(__('You are not allowed to change this entry status'));
 			}
@@ -733,4 +1260,8 @@
 	public function updPostSelected($id,$selected)
 	{
+		if (!$this->core->auth->check('usage,contentadmin',$this->id)) {
+			throw new Exception(__('You are not allowed to change this entry category'));
+		}
+		
 		$id = (integer) $id;
 		$selected = (boolean) $selected;
@@ -745,7 +1276,7 @@
 					"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 			
-			$posts = $this->con->select($strReq);
-			
-			if (count($posts) == 0) {
+			$rs = $this->con->select($strReq);
+			
+			if ($rs->isEmpty()) {
 				throw new Exception(__('You are not allowed to mark this entry as selected'));
 			}
@@ -765,21 +1296,19 @@
 	
 	/**
-	Deletes a post.
+	Updates post category. <var>$cat_id</var> can be null.
 	
 	@param	id		<b>integer</b>		Post ID
-	*/
-	public function delPost($id)
-	{
-		if (!$this->core->auth->check('delete,contentadmin',$this->id)) {
-			throw new Exception(__('You are not allowed to delete entries'));
+	@param	cat_id	<b>integer</b>		Category ID
+	*/
+	public function updPostCategory($id,$cat_id)
+	{
+		if (!$this->core->auth->check('usage,contentadmin',$this->id)) {
+			throw new Exception(__('You are not allowed to change this entry category'));
 		}
 		
 		$id = (integer) $id;
-		
-		if (empty($id)) {
-			throw new Exception(__('No such entry ID'));
-		}
-		
-		#If user can only delete, we need to check the post's owner
+		$cat_id = (integer) $cat_id;
+		
+		# If user is only usage, we need to check the post's owner
 		if (!$this->core->auth->check('contentadmin',$this->id))
 		{
@@ -790,7 +1319,52 @@
 					"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 			
-			$posts = $this->con->select($strReq);
-			
-			if (count($posts) == 0) {
+			$rs = $this->con->select($strReq);
+			
+			if ($rs->isEmpty()) {
+				throw new Exception(__('You are not allowed to change this entry category'));
+			}
+		}
+		
+		$cur = $this->con->openCursor($this->prefix.'post');
+		
+		$cur->cat_id = ($cat_id ? $cat_id : null);
+		$cur->post_upddt = date('Y-m-d H:i:s');
+		
+		$cur->update(
+			'WHERE post_id = '.$id.' '.
+			"AND blog_id = '".$this->con->escape($this->id)."' "
+		);
+		$this->triggerBlog();
+	}
+	
+	/**
+	Deletes a post.
+	
+	@param	id		<b>integer</b>		Post ID
+	*/
+	public function delPost($id)
+	{
+		if (!$this->core->auth->check('delete,contentadmin',$this->id)) {
+			throw new Exception(__('You are not allowed to delete entries'));
+		}
+		
+		$id = (integer) $id;
+		
+		if (empty($id)) {
+			throw new Exception(__('No such entry ID'));
+		}
+		
+		#If user can only delete, we need to check the post's owner
+		if (!$this->core->auth->check('contentadmin',$this->id))
+		{
+			$strReq = 'SELECT post_id '.
+					'FROM '.$this->prefix.'post '.
+					'WHERE post_id = '.$id.' '.
+					"AND blog_id = '".$this->con->escape($this->id)."' ".
+					"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
+			
+			$rs = $this->con->select($strReq);
+			
+			if ($rs->isEmpty()) {
 				throw new Exception(__('You are not allowed to delete this entry'));
 			}
@@ -816,24 +1390,24 @@
 				"AND blog_id = '".$this->con->escape($this->id)."' ";
 		
-		$posts = $this->con->select($strReq);
+		$rs = $this->con->select($strReq);
 		
 		$now = dt::toUTC(time());
 		$to_change = new ArrayObject();
 
-		if (count($posts) == 0) {
+		if ($rs->isEmpty()) {
 			return;
 		}
 		
-		foreach ($posts as $post)
+		while ($rs->fetch())
 		{
 			# Now timestamp with post timezone
-			$now_tz = $now + dt::getTimeOffset($post->post_tz,$now);
+			$now_tz = $now + dt::getTimeOffset($rs->post_tz,$now);
 			
 			# Post timestamp
-			$post_ts = strtotime($post->post_dt);
+			$post_ts = strtotime($rs->post_dt);
 			
 			# If now_tz >= post_ts, we publish the entry
 			if ($now_tz >= $post_ts) {
-				$to_change[] = (integer) $post->post_id;
+				$to_change[] = (integer) $rs->post_id;
 			}
 		}
@@ -880,4 +1454,73 @@
 	}
 	
+	private function getPostsCategoryFilter($arr,$field='cat_id')
+	{
+		$field = $field == 'cat_id' ? 'cat_id' : 'cat_url';
+		
+		$sub = array();
+		$not = array();
+		$queries = array();
+		
+		foreach ($arr as $v)
+		{
+			$v = trim($v);
+			$args = preg_split('/\s*[?]\s*/',$v,-1,PREG_SPLIT_NO_EMPTY);
+			$id = array_shift($args);
+			$args = array_flip($args);
+			
+			if (isset($args['not'])) { $not[$id] = 1; }
+			if (isset($args['sub'])) { $sub[$id] = 1; }
+			if ($field == 'cat_id') {
+				if (preg_match('/^null$/i',$id)) {
+					$queries[$id] = 'P.cat_id IS NULL';
+				}
+				else {
+					$queries[$id] = 'P.cat_id = '.(integer) $id;
+				}
+			} else {
+				$queries[$id] = "C.cat_url = '".$this->con->escape($id)."' ";
+			}
+		}
+		
+		if (!empty($sub)) {
+			$rs = $this->con->select(
+				'SELECT cat_id, cat_url, cat_lft, cat_rgt FROM '.$this->prefix.'category '.
+				"WHERE blog_id = '".$this->con->escape($this->id)."' ".
+				'AND '.$field.' '.$this->con->in(array_keys($sub))
+			);
+			
+			while ($rs->fetch()) {
+				$queries[$rs->f($field)] = '(C.cat_lft BETWEEN '.$rs->cat_lft.' AND '.$rs->cat_rgt.')';
+			}
+		}
+		
+		# Create queries
+		$sql = array(
+			0 => array(), # wanted categories
+			1 => array()  # excluded categories
+		);
+		
+		foreach ($queries as $id => $q) {
+			$sql[(integer) isset($not[$id])][] = $q;
+		}
+		
+		$sql[0] = implode(' OR ',$sql[0]);
+		$sql[1] = implode(' OR ',$sql[1]);
+		
+		if ($sql[0]) {
+			$sql[0] = '('.$sql[0].')';
+		} else {
+			unset($sql[0]);
+		}
+		
+		if ($sql[1]) {
+			$sql[1] = '(P.cat_id IS NULL OR NOT('.$sql[1].'))';
+		} else {
+			unset($sql[1]);
+		}
+		
+		return implode(' AND ',$sql);
+	}
+	
 	private function getPostCursor($cur,$post_id=null)
 	{
@@ -888,4 +1531,8 @@
 		if ($cur->post_content == '') {
 			throw new Exception(__('No entry content'));
+		}
+		
+		if ($cur->post_password === '') {
+			$cur->post_password = null;
 		}
 		
@@ -1023,7 +1670,7 @@
 				'ORDER BY post_url DESC';
 		
-		$urls = $this->con->select($strReq);
-		
-		if (count($urls) > 0)
+		$rs = $this->con->select($strReq);
+		
+		if (!$rs->isEmpty())
 		{
 			if ($this->con->driver() == 'mysql') {
@@ -1040,8 +1687,8 @@
 					'ORDER BY post_url DESC ';
 			
-			$urls = $this->con->select($strReq);
+			$rs = $this->con->select($strReq);
 			$a = array();
-			foreach ($urls as $u) {
-				$a[] = $u->post_url;
+			while ($rs->fetch()) {
+				$a[] = $rs->post_url;
 			}
 			
